[**@rickosborne/foundation v2024.12.27**](../README.md)

***

[@rickosborne/foundation](../README.md) / addProperties

# Function: addProperties()

> **addProperties**\<`T`, `K`, `R`\>(`target`, `descriptors`): \{ \[k in string \| number \| symbol\]: (T & \{ readonly \[K in string \| number \| symbol\]: R\[K\] extends TypedPropertyDescriptor\<V\> ? V : never \} & \{ \[K in string \| number \| symbol\]: R\[K\] extends TypedPropertyDescriptor\<V\> ? V : never \} & \{ \[K in \`$\{string\}IsWriteOnly\`\]?: undefined \})\[k\] \}

A more type-friendly version of <kbd>Object.defineProperties</kbd>.

## Type Parameters

• **T**

• **K** *extends* `string`

• **R** *extends* `Record`\<`K`, [`TypedPropertyDescriptor`](../type-aliases/TypedPropertyDescriptor.md)\<`unknown`\>\>

## Parameters

### target

`T`

### descriptors

`R`

## Returns

\{ \[k in string \| number \| symbol\]: (T & \{ readonly \[K in string \| number \| symbol\]: R\[K\] extends TypedPropertyDescriptor\<V\> ? V : never \} & \{ \[K in string \| number \| symbol\]: R\[K\] extends TypedPropertyDescriptor\<V\> ? V : never \} & \{ \[K in \`$\{string\}IsWriteOnly\`\]?: undefined \})\[k\] \}

## See

[on MDN](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperties|Object.defineProperties)

## Defined in

[foundation/ts/add-property.ts:160](https://github.com/rickosborne/es-js-ts/blob/78a07c48a8ee66acad83b938575d051189c41326/foundation/ts/add-property.ts#L160)
