[**@rickosborne/foundation v2024.12.27**](../README.md)

***

[@rickosborne/foundation](../README.md) / addProperty

# Function: addProperty()

> **addProperty**\<`T`, `K`, `V`, `D`\>(`target`, `key`, `descriptor`): \{ \[k in string \| number \| symbol\]: (T & PropertyFromDescriptor\<K, D\>)\[k\] \}

A more type-friendly version of <kbd>Object.defineProperty</kbd>.

## Type Parameters

• **T**

• **K** *extends* `string`

• **V**

• **D** *extends* [`TypedPropertyDescriptor`](../type-aliases/TypedPropertyDescriptor.md)\<`V`\>

## Parameters

### target

`T`

### key

`K`

### descriptor

`D`

## Returns

\{ \[k in string \| number \| symbol\]: (T & PropertyFromDescriptor\<K, D\>)\[k\] \}

## See

[on MDN](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperty|Object.defineProperty)

## Defined in

[foundation/ts/add-property.ts:152](https://github.com/rickosborne/es-js-ts/blob/78a07c48a8ee66acad83b938575d051189c41326/foundation/ts/add-property.ts#L152)
